module GCode where

data CType = CDouble | CInt | CChar deriving Show

data GInstr = Eval 
	    | Unwind
	    | Return
        | Update Int
        | Alloc Int
	    | Push Int
	    | PushGlobal String
	    | PushInt Int
	    | PushFloat Double
        | PushBool Bool
        | PushChar Char
	    | Pop Int
	    | Slide Int
        | Label String
        | JFalse String
        | Jump String
	    | MkAp
        | AddInt | SubInt | MulInt | DivInt | RemInt | NegInt
        | EqInt | NEInt | LTInt | LEInt
        | AddFloat | SubFloat | MulFloat | DivFloat | RemFloat | NegFloat
        | EqFloat | NEFloat | LTFloat | LEFloat
        | AndBool | OrBool | NotBool | EqvBool | NEvBool
        | EqChar | NEChar | LTChar | LEChar
        | CallCFun (Maybe CType) [CType] String
        | IntToFloat | FloatToInt
	deriving Show

data GTop = GFun String Int [GInstr] deriving Show

type GProg = [GTop]

