undefined = (fn a => undefined a) :: {a} a
;
id = (fn a => fn x => x) :: {a} a -> a
;
add = (fn a => casetype a of {
    Star => Sum;
    Unit => fn x => fn y => unit;
    Int => addint;
    Float => addfloat;
    Char => undefined (Char -> Char -> Char);
    Bool => or;
    Pair a b => fn x => fn y => pair a b (add a (fst a b x) (fst a b y)) (add b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b (Sum a b) x (fn q => case a b (Sum a b) y (fn w => inl a b (add a q w)) (fn w => undefined (Sum a b))) (fn q => case a b (Sum a b) y (fn w => undefined (Sum a b)) (fn w => inr a b (add b q w)));
    Arrow a b => fn x => fn y => fn z => add b (x z) (y z);
    {t::a} b => fn x => fn y => fn z => add (b z) (x z) (y z)}) :: {a} a -> a -> a
;
mul = (fn a => casetype a of {
    Star => Pair;
    Unit => fn x => fn y => unit;
    Int => mulint;
    Float => mulfloat;
    Char => undefined (Char -> Char -> Char);
    Bool => and;
    Pair a b => fn x => fn y => pair a b (mul a (fst a b x) (fst a b y)) (mul b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b (Sum a b) x (fn q => case a b (Sum a b) y (fn w => inl a b (mul a q w)) (fn w => undefined (Sum a b))) (fn q => case a b (Sum a b) y (fn w => undefined (Sum a b)) (fn w => inr a b (mul b q w)));
    Arrow a b => fn x => fn y => fn z => mul b (x z) (y z);
    {t::a} b => fn x => fn y => fn z => mul (b z) (x z) (y z)}) :: {a} a -> a -> a
;
sub = (fn a => casetype a of {
    Star => undefined (a -> a -> a);
    Unit => fn x => fn y => unit;
    Int => subint;
    Float => subfloat;
    Char => undefined (Char -> Char -> Char);
    Bool => fn x => fn y => and x (not y);
    Pair a b => fn x => fn y => pair a b (sub a (fst a b x) (fst a b y)) (sub b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b (Sum a b) x (fn q => case a b (Sum a b) y (fn w => inl a b (sub a q w)) (fn w => undefined (Sum a b))) (fn q => case a b (Sum a b) y (fn w => undefined (Sum a b)) (fn w => inr a b (sub b q w)));
    Arrow a b => fn x => fn y => fn z => sub b (x z) (y z);
    {t::a} b => fn x => fn y => fn z => sub (b z) (x z) (y z)}) :: {a} a -> a -> a
;
div = (fn a => casetype a of {
    Star => undefined (a -> a -> a);
    Unit => fn x => fn y => unit;
    Int => divint;
    Float => divfloat;
    Char => undefined (Char -> Char -> Char);
    Bool => undefined (a -> a -> a);
    Pair a b => fn x => fn y => pair a b (div a (fst a b x) (fst a b y)) (div b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b (Sum a b) x (fn q => case a b (Sum a b) y (fn w => inl a b (div a q w)) (fn w => undefined (Sum a b))) (fn q => case a b (Sum a b) y (fn w => undefined (Sum a b)) (fn w => inr a b (div b q w)));
    Arrow a b => fn x => fn y => fn z => div b (x z) (y z);
    {t::a} b => fn x => fn y => fn z => div (b z) (x z) (y z)}) :: {a} a -> a -> a
;
rem = (fn a => casetype a of {
    Star => undefined (a -> a -> a);
    Unit => fn x => fn y => unit;
    Int => remint;
    Float => remfloat;
    Char => undefined (Char -> Char -> Char);
    Bool => undefined (a -> a -> a);
    Pair a b => fn x => fn y => pair a b (rem a (fst a b x) (fst a b y)) (rem b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b (Sum a b) x (fn q => case a b (Sum a b) y (fn w => inl a b (rem a q w)) (fn w => undefined (Sum a b))) (fn q => case a b (Sum a b) y (fn w => undefined (Sum a b)) (fn w => inr a b (rem b q w)));
    Arrow a b => fn x => fn y => fn z => rem b (x z) (y z);
    {t::a} b => fn x => fn y => fn z => rem (b z) (x z) (y z)}) :: {a} a -> a -> a
;
eq = (fn z => casetype z of {
    Star => undefined (z -> z -> Bool);
    Unit => fn x => fn y => true;
    Int => eqint;
    Float => eqfloat;
    Char => undefined (Char -> Char -> Bool);
    Bool => eqv;
    Pair a b => fn x => fn y => and (eq a (fst a b x) (fst a b y)) (eq b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b Bool x (fn q => case a b Bool y (fn w => eq a q w) (fn w => false)) (fn q => case a b Bool y (fn w => false) (fn w => eq b q w));
    Arrow a b => undefined (z -> z -> Bool);
    {t::a} b => undefined (z -> z -> Bool)}) :: {a} a -> a -> Bool
;
neq = (fn z => casetype z of {
    Star => undefined (z -> z -> Bool);
    Unit => fn x => fn y => false;
    Int => neint;
    Float => nefloat;
    Char => undefined (Char -> Char -> Bool);
    Bool => neqv;
    Pair a b => fn x => fn y => or (neq a (fst a b x) (fst a b y)) (neq b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b Bool x (fn q => case a b Bool y (fn w => neq a q w) (fn w => true)) (fn q => case a b Bool y (fn w => true) (fn w => neq b q w));
    Arrow a b => undefined (z -> z -> Bool);
    {t::a} b => undefined (z -> z -> Bool)}) :: {a} a -> a -> Bool
;
leq = (fn z => casetype z of {
    Star => undefined (z -> z -> Bool);
    Unit => fn x => fn y => true;
    Int => leint;
    Float => lefloat;
    Char => undefined (Char -> Char -> Bool);
    Bool => fn x => fn y => or (not x) y;
    Pair a b => fn x => fn y => or (leq a (fst a b x) (fst a b y)) (leq b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b Bool x (fn q => case a b Bool y (fn w => leq a q w) (fn w => true)) (fn q => case a b Bool y (fn w => false) (fn w => leq b q w));
    Arrow a b => undefined (z -> z -> Bool);
    {t::a} b => undefined (z -> z -> Bool)}) :: {a} a -> a -> Bool
;
lt = (fn z => casetype z of {
    Star => undefined (z -> z -> Bool);
    Unit => fn x => fn y => false;
    Int => ltint;
    Float => ltfloat;
    Char => undefined (Char -> Char -> Bool);
    Bool => fn x => fn y => and (not x) y;
    Pair a b => fn x => fn y => or (lt a (fst a b x) (fst a b y)) (lt b (snd a b x) (snd a b y));
    Sum a b => fn x => fn y => case a b Bool x (fn q => case a b Bool y (fn w => lt a q w) (fn w => true)) (fn q => case a b Bool y (fn w => false) (fn w => lt b q w));
    Arrow a b => undefined (z -> z -> Bool);
    {t::a} b => undefined (z -> z -> Bool)}) :: {a} a -> a -> Bool
;
geq = (fn z => fn a => fn b => leq z b a) :: {a} a -> a -> Bool
;
gt = (fn z => fn a => fn b => lt z b a) :: {a} a -> a -> Bool
;
neg = (fn z => casetype z of {
    Star => undefined (z -> z); # kontynuacje?
    Unit => fn x => unit;
    Int => negint;
    Float => negfloat;
    Char => undefined (z -> z);
    Bool => not;
    Pair a b => fn x => pair a b (neg a (fst a b x)) (neg b (snd a b x));
    Sum a b => fn x => case a b (Sum a b) x (fn q => inl a b (neg a q)) (fn q => inr a b (neg b q));
    Arrow a b => fn x => fn y => neg b (x y);
    {t::a} b => fn x => fn y => neg (b y) (x y)}) :: {a} a -> a
;
plist = (fn a => fn x => Sum Unit (Pair a x)) :: Star -> Star -> Star
;
List = (fn a => Fix Star (plist a)) :: Star -> Star
;
nil = (fn a => wrap Star (plist a) (inl Unit (Pair a (List a)) unit)) :: {a} List a
;
cons = (fn a => fn h => fn t => wrap Star (plist a) (inr Unit (Pair a (List a)) (pair a (List a) h t))) :: {a} a -> List a -> List a
;
head = (fn a => fn l => case Unit (Pair a (List a)) a (unwrap Star (plist a) l) (fn h => undefined a) (fn t => fst a (List a) t)) :: {a} List a -> a
;
tail = (fn a => fn l => case Unit (Pair a (List a)) (List a) (unwrap Star (plist a) l) (fn h => undefined (List a)) (fn t => snd a (List a) t)) :: {a} List a -> List a
;
isempty = (fn a => fn l => case Unit (Pair a (List a)) Bool (unwrap Star (plist a) l) (fn h => true) (fn t => false)) :: {a} List a -> Bool
;
String = List Char :: Star
;
printstring = (fn x => if isempty Char x then return Unit unit else bind Unit Unit (printchar (head Char x)) (fn y => printstring (tail Char x))) :: String -> IO Unit
